GNU Radio C++ API Reference: gr::soapy::block Class Reference

| GNU Radio C++ API Reference 3.10.12.0 The Free & Open Software Radio Ecosystem |

Loading...
Searching...
No Matches
gr::soapy::block Class Referenceabstract

`#include <gnuradio/soapy/block.h>`

## Public Member Functions
virtual std::string | get_driver_key () const =0
virtual std::string | get_hardware_key () const =0
virtual kwargs_t | get_hardware_info () const =0
virtual void | set_frontend_mapping (const std::string &frontend_mapping)=0
virtual std::string | get_frontend_mapping () const =0
virtual kwargs_t | get_channel_info (size_t channel) const =0
virtual void | set_sample_rate (size_t channel, double sample_rate)=0
virtual double | get_sample_rate (size_t channel) const =0
virtual range_list_t | get_sample_rate_range (size_t channel) const =0
virtual void | set_frequency (size_t channel, double freq)=0
virtual void | set_frequency (size_t channel, const std::string &name, double freq)=0
virtual double | get_frequency (size_t channel) const =0
virtual double | get_frequency (size_t channel, const std::string &name) const =0
virtual std::vector< std::string > | list_frequencies (size_t channel) const =0
virtual range_list_t | get_frequency_range (size_t channel) const =0
virtual range_list_t | get_frequency_range (size_t channel, const std::string &name) const =0
virtual arginfo_list_t | get_frequency_args_info (size_t channel) const =0
virtual void | set_bandwidth (size_t channel, double bandwidth)=0
virtual double | get_bandwidth (size_t channel) const =0
virtual range_list_t | get_bandwidth_range (size_t channel) const =0
virtual std::vector< std::string > | list_antennas (int channel) const =0
virtual void | set_antenna (size_t channel, const std::string &name)=0
virtual std::string | get_antenna (size_t channel) const =0
virtual bool | has_gain_mode (size_t channel) const =0
virtual void | set_gain_mode (size_t channel, bool enable)=0
virtual bool | get_gain_mode (size_t channel) const =0
virtual std::vector< std::string > | list_gains (size_t channel) const =0
virtual void | set_gain (size_t channel, double gain)=0
virtual void | set_gain (size_t channel, const std::string &name, double gain)=0
virtual double | get_gain (size_t channel) const =0
virtual double | get_gain (size_t channel, const std::string &name) const =0
virtual range_t | get_gain_range (size_t channel) const =0
virtual range_t | get_gain_range (size_t channel, const std::string &name) const =0
virtual bool | has_frequency_correction (size_t channel) const =0
virtual void | set_frequency_correction (size_t channel, double freq_correction)=0
virtual double | get_frequency_correction (size_t channel) const =0
virtual bool | has_dc_offset_mode (size_t channel) const =0
virtual void | set_dc_offset_mode (size_t channel, bool automatic)=0
virtual bool | get_dc_offset_mode (size_t channel) const =0
virtual bool | has_dc_offset (size_t channel) const =0
virtual void | set_dc_offset (size_t channel, const gr_complexd &dc_offset)=0
virtual gr_complexd | get_dc_offset (size_t channel) const =0
virtual bool | has_iq_balance (size_t channel) const =0
virtual void | set_iq_balance (size_t channel, const gr_complexd &iq_balance)=0
virtual gr_complexd | get_iq_balance (size_t channel) const =0
virtual bool | has_iq_balance_mode (size_t channel) const =0
virtual void | set_iq_balance_mode (size_t channel, bool automatic)=0
virtual bool | get_iq_balance_mode (size_t channel) const =0
virtual void | set_master_clock_rate (double clock_rate)=0
virtual double | get_master_clock_rate () const =0
virtual range_list_t | get_master_clock_rates () const =0
virtual void | set_reference_clock_rate (double rate)=0
virtual double | get_reference_clock_rate () const =0
virtual range_list_t | get_reference_clock_rates () const =0
virtual std::vector< std::string > | list_clock_sources () const =0
virtual void | set_clock_source (const std::string &clock_source)=0
virtual std::string | get_clock_source () const =0
virtual std::vector< std::string > | list_time_sources () const =0
virtual void | set_time_source (const std::string &source)=0
virtual std::string | get_time_source () const =0
virtual bool | has_hardware_time (const std::string &what="") const =0
virtual long long | get_hardware_time (const std::string &what="") const =0
virtual void | set_hardware_time (long long timeNs, const std::string &what="")=0
virtual std::vector< std::string > | list_sensors () const =0
virtual arginfo_t | get_sensor_info (const std::string &key) const =0
virtual std::string | read_sensor (const std::string &key) const =0
virtual std::vector< std::string > | list_sensors (size_t channel) const =0
virtual arginfo_t | get_sensor_info (size_t channel, const std::string &key) const =0
virtual std::string | read_sensor (size_t channel, const std::string &key) const =0
virtual std::vector< std::string > | list_register_interfaces () const =0
virtual void | write_register (const std::string &name, unsigned addr, unsigned value)=0
virtual unsigned | read_register (const std::string &name, unsigned addr) const =0
virtual void | write_registers (const std::string &name, unsigned addr, const std::vector< unsigned > &value)=0
virtual std::vector< unsigned > | read_registers (const std::string &name, unsigned addr, size_t length) const =0
virtual arginfo_list_t | get_setting_info () const =0
virtual void | write_setting (const std::string &key, const std::string &value)=0
virtual std::string | read_setting (const std::string &key) const =0
virtual arginfo_list_t | get_setting_info (size_t channel) const =0
virtual void | write_setting (size_t channel, const std::string &key, const std::string &value)=0
virtual std::string | read_setting (size_t channel, const std::string &key) const =0
virtual std::vector< std::string > | list_gpio_banks () const =0
virtual void | write_gpio (const std::string &bank, unsigned value)=0
virtual void | write_gpio (const std::string &bank, unsigned value, unsigned mask)=0
virtual unsigned | read_gpio (const std::string &bank) const =0
virtual void | write_gpio_dir (const std::string &bank, unsigned dir)=0
virtual void | write_gpio_dir (const std::string &bank, unsigned dir, unsigned mask)=0
virtual unsigned | read_gpio_dir (const std::string &bank) const =0
virtual void | write_i2c (int addr, const std::string &data)=0
virtual std::string | read_i2c (int addr, size_t num_bytes)=0
virtual unsigned | transact_spi (int addr, unsigned data, size_t num_bits)=0
virtual std::vector< std::string > | list_uarts () const =0
virtual void | write_uart (const std::string &which, const std::string &data)=0
virtual std::string | read_uart (const std::string &which, long timeout_us=100000) const =0
Public Member Functions inherited from gr::block
| ~block () override
unsigned | history () const
void | set_history (unsigned history)
void | declare_sample_delay (int which, unsigned delay)
void | declare_sample_delay (unsigned delay)
unsigned | sample_delay (int which) const
bool | fixed_rate () const
| Return true if this block has a fixed input to output rate.
virtual void | forecast (int noutput_items, gr_vector_int &ninput_items_required)
| Estimate input requirements given output request.
virtual int | general_work (int noutput_items, gr_vector_int &ninput_items, gr_vector_const_void_star &input_items, gr_vector_void_star &output_items)
| compute output items from input items
virtual bool | start ()
| Called to enable drivers, etc for i/o devices.
virtual bool | stop ()
| Called to disable drivers, etc for i/o devices.
void | set_output_multiple (int multiple)
| Constrain the noutput_items argument passed to forecast and general_work.
int | output_multiple () const
bool | output_multiple_set () const
void | set_alignment (int multiple)
| Constrains buffers to work on a set item alignment (for SIMD).
int | alignment () const
void | set_unaligned (int na)
int | unaligned () const
void | set_is_unaligned (bool u)
bool | is_unaligned () const
void | consume (int which_input, int how_many_items)
| Tell the scheduler `how_many_items` of input stream `which_input` were consumed.
void | consume_each (int how_many_items)
| Tell the scheduler `how_many_items` were consumed on each input stream.
void | produce (int which_output, int how_many_items)
| Tell the scheduler `how_many_items` were produced on output stream `which_output`.
void | set_relative_rate (double relative_rate)
| Set the approximate output rate / input rate.
void | set_inverse_relative_rate (double inverse_relative_rate)
| Set the approximate output rate / input rate using its reciprocal.
void | set_relative_rate (uint64_t interpolation, uint64_t decimation)
| Set the approximate output rate / input rate as an integer ratio.
double | relative_rate () const
| return the approximate output rate / input rate
uint64_t | relative_rate_i () const
| return the numerator, or interpolation rate, of the approximate output rate / input rate
uint64_t | relative_rate_d () const
| return the denominator, or decimation rate, of the approximate output rate / input rate
mpq_class & | mp_relative_rate ()
| return a reference to the multiple precision rational representation of the approximate output rate / input rate
virtual int | fixed_rate_ninput_to_noutput (int ninput)
| Given ninput samples, return number of output samples that will be produced. N.B. this is only defined if fixed_rate returns true. Generally speaking, you don't need to override this.
virtual int | fixed_rate_noutput_to_ninput (int noutput)
| Given noutput samples, return number of input samples required to produce noutput. N.B. this is only defined if fixed_rate returns true. Generally speaking, you don't need to override this.
uint64_t | nitems_read (unsigned int which_input)
| Return the number of items read on input stream which_input.
uint64_t | nitems_written (unsigned int which_output)
| Return the number of items written on output stream which_output.
tag_propagation_policy_t | tag_propagation_policy ()
| Asks for the policy used by the scheduler to moved tags downstream.
void | set_tag_propagation_policy (tag_propagation_policy_t p)
| Set the policy by the scheduler to determine how tags are moved downstream.
int | min_noutput_items () const
| Return the minimum number of output items this block can produce during a call to work.
void | set_min_noutput_items (int m)
| Set the minimum number of output items this block can produce during a call to work.
int | max_noutput_items ()
| Return the maximum number of output items this block will handle during a call to work.
void | set_max_noutput_items (int m)
| Set the maximum number of output items this block will handle during a call to work.
void | unset_max_noutput_items ()
| Clear the switch for using the max_noutput_items value of this block.
bool | is_set_max_noutput_items ()
| Ask the block if the flag is or is not set to use the internal value of max_noutput_items during a call to work.
void | expand_minmax_buffer (int port)
long | max_output_buffer (size_t i)
| Returns max buffer size on output port `i`.
void | set_max_output_buffer (long max_output_buffer)
| Request limit on max buffer size on all output ports.
void | set_max_output_buffer (int port, long max_output_buffer)
| Request limit on max buffer size on output port `port`.
long | min_output_buffer (size_t i)
| Returns min buffer size on output port `i`.
void | set_min_output_buffer (long min_output_buffer)
| Request limit on the minimum buffer size on all output ports.
void | set_min_output_buffer (int port, long min_output_buffer)
| Request limit on min buffer size on output port `port`.
void | set_blkd_input_timer_value (unsigned int timer_value_ms)
| DEPRECATED Configure the timer set when input is blocked `port`.
unsigned int | blkd_input_timer_value ()
| DEPRECATED Returns timer value set when input is blocked.
void | allocate_detail (int ninputs, int noutputs, const std::vector< int > &downstream_max_nitems_vec, const std::vector< uint64_t > &downstream_lcm_nitems_vec, const std::vector< uint32_t > &downstream_max_out_mult_vec)
| Allocate the block_detail and necessary output buffers for this block.
buffer_sptr | replace_buffer (size_t src_port, size_t dst_port, block_sptr block_owner)
| Replace the block's buffer with a new one owned by the block_owner parameter.
float | pc_noutput_items ()
| Gets instantaneous noutput_items performance counter.
float | pc_noutput_items_avg ()
| Gets average noutput_items performance counter.
float | pc_noutput_items_var ()
| Gets variance of noutput_items performance counter.
float | pc_nproduced ()
| Gets instantaneous num items produced performance counter.
float | pc_nproduced_avg ()
| Gets average num items produced performance counter.
float | pc_nproduced_var ()
| Gets variance of num items produced performance counter.
float | pc_input_buffers_full (int which)
| Gets instantaneous fullness of `which` input buffer.
float | pc_input_buffers_full_avg (int which)
| Gets average fullness of `which` input buffer.
float | pc_input_buffers_full_var (int which)
| Gets variance of fullness of `which` input buffer.
std::vector< float > | pc_input_buffers_full ()
| Gets instantaneous fullness of all input buffers.
std::vector< float > | pc_input_buffers_full_avg ()
| Gets average fullness of all input buffers.
std::vector< float > | pc_input_buffers_full_var ()
| Gets variance of fullness of all input buffers.
float | pc_output_buffers_full (int which)
| Gets instantaneous fullness of `which` output buffer.
float | pc_output_buffers_full_avg (int which)
| Gets average fullness of `which` output buffer.
float | pc_output_buffers_full_var (int which)
| Gets variance of fullness of `which` output buffer.
std::vector< float > | pc_output_buffers_full ()
| Gets instantaneous fullness of all output buffers.
std::vector< float > | pc_output_buffers_full_avg ()
| Gets average fullness of all output buffers.
std::vector< float > | pc_output_buffers_full_var ()
| Gets variance of fullness of all output buffers.
float | pc_work_time ()
| Gets instantaneous clock cycles spent in work.
float | pc_work_time_avg ()
| Gets average clock cycles spent in work.
float | pc_work_time_var ()
| Gets average clock cycles spent in work.
float | pc_work_time_total ()
| Gets total clock cycles spent in work.
float | pc_throughput_avg ()
| Gets average throughput.
void | reset_perf_counters ()
| Resets the performance counters.
void | setup_pc_rpc ()
| Sets up export of perf. counters to ControlPort. Only called by the scheduler.
bool | is_pc_rpc_set () const
| Checks if this block is already exporting perf. counters to ControlPort.
void | no_pc_rpc ()
| If the block calls this in its constructor, it's perf. counters will not be exported.
void | set_processor_affinity (const std::vector< int > &mask) override
| Set the thread's affinity to processor core `n`.
void | unset_processor_affinity () override
| Remove processor affinity to a specific core.
std::vector< int > | processor_affinity () override
| Get the current processor affinity.
int | active_thread_priority ()
| Get the current thread priority in use.
int | thread_priority ()
| Get the current thread priority stored.
int | set_thread_priority (int priority)
| Set the current thread priority.
bool | update_rate () const
void | system_handler (pmt::pmt_t msg)
| the system message handler
void | set_log_level (const std::string &level) override
| Set the logger's output level.
std::string | log_level () override
| Get the logger's output level.
bool | finished ()
| returns true when execution has completed due to a message connection
block_detail_sptr | detail () const
void | set_detail (block_detail_sptr detail)
void | notify_msg_neighbors ()
| Tell msg neighbors we are finished.
void | clear_finished ()
| Make sure we don't think we are finished.
std::string | identifier () const
Public Member Functions inherited from gr::basic_block
pmt::pmt_t | message_subscribers (pmt::pmt_t port)
| ~basic_block () override
long | unique_id () const
long | symbolic_id () const
std::string | name () const
std::string | symbol_name () const
std::string | identifier () const
gr::io_signature::sptr | input_signature () const
gr::io_signature::sptr | output_signature () const
basic_block_sptr | to_basic_block ()
bool | alias_set () const
std::string | alias () const
pmt::pmt_t | alias_pmt () const
void | set_block_alias (std::string name)
void | message_port_register_in (pmt::pmt_t port_id)
void | message_port_register_out (pmt::pmt_t port_id)
void | message_port_pub (pmt::pmt_t port_id, pmt::pmt_t msg)
void | message_port_sub (pmt::pmt_t port_id, pmt::pmt_t target)
void | message_port_unsub (pmt::pmt_t port_id, pmt::pmt_t target)
virtual bool | message_port_is_hier (pmt::pmt_t port_id)
virtual bool | message_port_is_hier_in (pmt::pmt_t port_id)
virtual bool | message_port_is_hier_out (pmt::pmt_t port_id)
pmt::pmt_t | message_ports_in ()
| Get input message port names.
pmt::pmt_t | message_ports_out ()
| Get output message port names.
void | _post (pmt::pmt_t which_port, pmt::pmt_t msg)
bool | empty_p (pmt::pmt_t which_port)
| is the queue empty?
bool | empty_p ()
bool | empty_handled_p (pmt::pmt_t which_port)
| are all msg ports with handlers empty?
bool | empty_handled_p ()
size_t | nmsgs (pmt::pmt_t which_port)
| How many messages in the queue?
void | insert_tail (pmt::pmt_t which_port, pmt::pmt_t msg)
pmt::pmt_t | delete_head_nowait (pmt::pmt_t which_port)
msg_queue_t::iterator | get_iterator (pmt::pmt_t which_port)
void | erase_msg (pmt::pmt_t which_port, msg_queue_t::iterator it)
virtual bool | has_msg_port (pmt::pmt_t which_port)
const msg_queue_map_t & | get_msg_map (void) const
void | add_rpc_variable (rpcbasic_sptr s)
| Add an RPC variable (get or set).
virtual void | setup_rpc ()
| Set up the RPC registered variables.
bool | is_rpc_set ()
| Ask if this block has been registered to the RPC.
void | rpc_set ()
| When the block is registered with the RPC, set this.
virtual bool | check_topology (int ninputs, int noutputs)
| Confirm that ninputs and noutputs is an acceptable combination.
template<typename T>
void | set_msg_handler (pmt::pmt_t which_port, T msg_handler)
| Set the callback that is fired when messages are available.
Public Member Functions inherited from gr::msg_accepter
| msg_accepter ()
| ~msg_accepter () override
void | post (pmt::pmt_t which_port, pmt::pmt_t msg) override
| send `msg` to `msg_accepter` on port `which_port`
Public Member Functions inherited from gr::messages::msg_accepter
| msg_accepter ()

## Additional Inherited Members
Public Types inherited from gr::block
enum | work_return_t { WORK_CALLED_PRODUCE = -2 , WORK_DONE = -1 }
| Magic return values from general_work. More...
enum | tag_propagation_policy_t { TPP_DONT = 0 , TPP_ALL_TO_ALL = 1 , TPP_ONE_TO_ONE = 2 , TPP_CUSTOM = 3 }
| enum to represent different tag propagation policies. More...
Protected Types inherited from gr::basic_block
enum | vcolor { WHITE , GREY , BLACK }
Protected Member Functions inherited from gr::block
| block (void)
| block (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
void | set_fixed_rate (bool fixed_rate)
void | add_item_tag (unsigned int which_output, uint64_t abs_offset, const pmt::pmt_t &key, const pmt::pmt_t &value, const pmt::pmt_t &srcid=pmt::PMT_F)
| Adds a new tag onto the given output buffer.
void | add_item_tag (unsigned int which_output, const tag_t &tag)
| Adds a new tag onto the given output buffer.
void | remove_item_tag (unsigned int which_input, uint64_t abs_offset, const pmt::pmt_t &key, const pmt::pmt_t &value, const pmt::pmt_t &srcid=pmt::PMT_F)
| DEPRECATED. Will be removed in 3.8.
void | remove_item_tag (unsigned int which_input, const tag_t &tag)
| DEPRECATED. Will be removed in 3.8.
void | get_tags_in_range (std::vector< tag_t > &v, unsigned int which_input, uint64_t abs_start, uint64_t abs_end)
| Given a [start,end), returns a vector of all tags in the range.
void | get_tags_in_range (std::vector< tag_t > &v, unsigned int which_input, uint64_t abs_start, uint64_t abs_end, const pmt::pmt_t &key)
| Given a [start,end), returns a vector of all tags in the range with a given key.
void | get_tags_in_window (std::vector< tag_t > &v, unsigned int which_input, uint64_t rel_start, uint64_t rel_end)
| Gets all tags within the relative window of the current call to work.
void | get_tags_in_window (std::vector< tag_t > &v, unsigned int which_input, uint64_t rel_start, uint64_t rel_end, const pmt::pmt_t &key)
| Operates like gr::block::get_tags_in_window with the ability to only return tags with the specified `key`.
void | enable_update_rate (bool en)
buffer_sptr | allocate_buffer (size_t port, int downstream_max_nitems, uint64_t downstream_lcm_nitems, uint32_t downstream_max_out_mult)
| Allocate a buffer for the given output port of this block. Note that the downstream max number of items must be passed in to this function for consideration.
Protected Member Functions inherited from gr::basic_block
| basic_block (void)
| basic_block (const std::string &name, gr::io_signature::sptr input_signature, gr::io_signature::sptr output_signature)
| Protected constructor prevents instantiation by non-derived classes.
void | set_input_signature (gr::io_signature::sptr iosig)
| may only be called during constructor
void | set_output_signature (gr::io_signature::sptr iosig)
| may only be called during constructor
void | set_color (vcolor color)
| Allow the flowgraph to set for sorting and partitioning.
vcolor | color () const
virtual bool | has_msg_handler (pmt::pmt_t which_port)
| Tests if there is a handler attached to port `which_port`.
virtual void | dispatch_msg (pmt::pmt_t which_port, pmt::pmt_t msg)
template<typename Derived>
std::shared_ptr< Derived > | shared_from_base ()
| This is meant to be called by derived classes (e.g. block) to get a shared pointer internally. This is needed because std::enable_shared_from_this doesn't seem to work with derived classes in an inheritance hierarchy.
Protected Attributes inherited from gr::block
std::vector< long > | d_max_output_buffer
std::vector< long > | d_min_output_buffer
unsigned int | d_blkd_input_timer_value = 250
gr::thread::mutex | d_setlock
const pmt::pmt_t | d_pmt_done
const pmt::pmt_t | d_system_port
Protected Attributes inherited from gr::basic_block
std::string | d_name
gr::io_signature::sptr | d_input_signature
gr::io_signature::sptr | d_output_signature
long | d_unique_id
long | d_symbolic_id
std::string | d_symbol_name
std::string | d_symbol_alias
vcolor | d_color
bool | d_rpc_set
gr::logger_ptr | d_logger
gr::logger_ptr | d_debug_logger
| Default logger.
msg_queue_map_t | msg_queue
| Verbose logger.
std::vector< rpcbasic_sptr > | d_rpc_vars
pmt::pmt_t | d_message_subscribers

## Member Function Documentation

## ◆ get_antenna()

virtual std::string gr::soapy::block::get_antenna | ( | size_t | channel | ) | const
| pure virtual

Get the selected antenna on RX chain.

Parameters

  channel | an available channel on the device

Returns
  the name of the selected antenna

## ◆ get_bandwidth()

virtual double gr::soapy::block::get_bandwidth | ( | size_t | channel | ) | const
| pure virtual

Get baseband filter width of the RX chain.

Parameters

  channel | an available channel on the device

Returns
  the baseband filter width in Hz

## ◆ get_bandwidth_range()

virtual range_list_t gr::soapy::block::get_bandwidth_range | ( | size_t | channel | ) | const
| pure virtual

Get the range of possible baseband filter widths.

Parameters

  channel | an available channel on the device

Returns
  a list of bandwidth ranges in Hz

## ◆ get_channel_info()

virtual kwargs_t gr::soapy::block::get_channel_info | ( | size_t | channel | ) | const
| pure virtual

Query a dictionary of available channel information. This dictionary can any number of values like decoder type, version, available functions... This information can be displayed to the user to help identify the instantiated channel.

Parameters

  channel | an available channel on the device

Returns
  channel information

## ◆ get_clock_source()

virtual std::string gr::soapy::block::get_clock_source | ( |  | ) | const
| pure virtual

Get the clock source of the device

Returns
  the name of the clock source

## ◆ get_dc_offset()

virtual gr_complexd gr::soapy::block::get_dc_offset | ( | size_t | channel | ) | const
| pure virtual

Get the DC offset correction.

Parameters

  channel | an available channel on the device

Returns
  the relative correction (1.0 max)

## ◆ get_dc_offset_mode()

virtual bool gr::soapy::block::get_dc_offset_mode | ( | size_t | channel | ) | const
| pure virtual

Get the automatic DC offset correction mode.

Parameters

  channel | an available channel on the device

Returns
  true for automatic offset correction

## ◆ get_driver_key()

virtual std::string gr::soapy::block::get_driver_key | ( |  | ) | const
| pure virtual

A key that uniquely identifies the device driver. This key identifies the underlying implementation. Several variants of a product may share a driver.

## ◆ get_frequency() [1/2]

virtual double gr::soapy::block::get_frequency | ( | size_t | channel | ) | const
| pure virtual

Get the down conversion frequency of the chain.

Parameters

  channel | an available channel on the device

Returns
  the center frequency in Hz

## ◆ get_frequency() [2/2]

virtual double gr::soapy::block::get_frequency | ( | size_t | channel,
|  | const std::string & | name ) const
| pure virtual

Get the frequency of a tunable element in the chain.

Parameters

  channel | an available channel on the device
  name | the name of a tunable element

Returns
  the tunable element's frequency in Hz

References gr::basic_block::name().

## ◆ get_frequency_args_info()

virtual arginfo_list_t gr::soapy::block::get_frequency_args_info | ( | size_t | channel | ) | const
| pure virtual

Query the argument info description for stream args.

Parameters

  channel | an available channel on the device

Returns
  a list of argument info structures

## ◆ get_frequency_correction()

virtual double gr::soapy::block::get_frequency_correction | ( | size_t | channel | ) | const
| pure virtual

Get the frequency correction value.

Parameters

  channel | an available channel on the device

Returns
  the correction value in PPM

## ◆ get_frequency_range() [1/2]

virtual range_list_t gr::soapy::block::get_frequency_range | ( | size_t | channel | ) | const
| pure virtual

Get the range of overall frequency values.

Parameters

  channel | an available channel on the device

Returns
  a list of frequency ranges in Hz

## ◆ get_frequency_range() [2/2]

virtual range_list_t gr::soapy::block::get_frequency_range | ( | size_t | channel,
|  | const std::string & | name ) const
| pure virtual

Get the range of tunable values for the specified element.

Parameters

  channel | an available channel on the device
  name | the name of a tunable element

Returns
  a list of frequency ranges in Hz

References gr::basic_block::name().

## ◆ get_frontend_mapping()

virtual std::string gr::soapy::block::get_frontend_mapping | ( |  | ) | const
| pure virtual

Get the frontend mapping of available DSP units to RF frontends. This mapping describes channel mapping and channel availability.

Returns
  a vendor-specific mapping string

## ◆ get_gain() [1/2]

virtual double gr::soapy::block::get_gain | ( | size_t | channel | ) | const
| pure virtual

Get the overall value of the gain elements in a chain

Parameters

  channel | an available channel on the device

Returns
  the value of the gain in dB

## ◆ get_gain() [2/2]

virtual double gr::soapy::block::get_gain | ( | size_t | channel,
|  | const std::string & | name ) const
| pure virtual

Get the value of an individual amplification element in a chain.

Parameters

  channel | an available channel on the device
  name | the name of an amplification element

Returns
  the value of the gain in dB

References gr::basic_block::name().

## ◆ get_gain_mode()

virtual bool gr::soapy::block::get_gain_mode | ( | size_t | channel | ) | const
| pure virtual

Get the automatic gain mode on the RX chain.

Parameters

  channel | an available channel on the device

Returns
  true for automatic gain setting

## ◆ get_gain_range() [1/2]

virtual range_t gr::soapy::block::get_gain_range | ( | size_t | channel | ) | const
| pure virtual

Get the overall range of possible gain values.

Parameters

  channel | an available channel on the device

Returns
  a list of gain ranges in dB

## ◆ get_gain_range() [2/2]

virtual range_t gr::soapy::block::get_gain_range | ( | size_t | channel,
|  | const std::string & | name ) const
| pure virtual

Get the range of possible gain values for a specific element.

Parameters

  channel | an available channel on the device
  name | the name of an amplification element

Returns
  a list of gain ranges in dB

References gr::basic_block::name().

## ◆ get_hardware_info()

virtual kwargs_t gr::soapy::block::get_hardware_info | ( |  | ) | const
| pure virtual

Query a dictionary of available device information. This dictionary can any number of values like vendor name, product name, revisions, serials... This information can be displayed to the user to help identify the instantiated device.

## ◆ get_hardware_key()

virtual std::string gr::soapy::block::get_hardware_key | ( |  | ) | const
| pure virtual

A key that uniquely identifies the hardware. This key should be meaningful to the user to optimize for the underlying hardware.

## ◆ get_hardware_time()

virtual long long gr::soapy::block::get_hardware_time | ( | const std::string & | what = "" | ) | const
| pure virtual

Read the time from the hardware clock on the device. The what argument can refer to a specific time counter.

Parameters

  what | optional argument

Returns
  the time in nanoseconds

## ◆ get_iq_balance()

virtual gr_complexd gr::soapy::block::get_iq_balance | ( | size_t | channel | ) | const
| pure virtual

Get the IQ balance correction.

Parameters

  channel | an available channel on the device

Returns
  the relative correction (1.0 max)

## ◆ get_iq_balance_mode()

virtual bool gr::soapy::block::get_iq_balance_mode | ( | size_t | channel | ) | const
| pure virtual

Get the automatic IQ balance corrections mode.

Parameters

  channel | an available channel on the device

Returns
  true for automatic correction

## ◆ get_master_clock_rate()

virtual double gr::soapy::block::get_master_clock_rate | ( |  | ) | const
| pure virtual

Get the master clock rate of the device.

Returns
  the clock rate in Hz

## ◆ get_master_clock_rates()

virtual range_list_t gr::soapy::block::get_master_clock_rates | ( |  | ) | const
| pure virtual

Get the range of available master clock rates.

Returns
  a list of clock rate ranges in Hz

## ◆ get_reference_clock_rate()

virtual double gr::soapy::block::get_reference_clock_rate | ( |  | ) | const
| pure virtual

Get the reference clock rate of the device.

Returns
  the clock rate in Hz

## ◆ get_reference_clock_rates()

virtual range_list_t gr::soapy::block::get_reference_clock_rates | ( |  | ) | const
| pure virtual

Get the range of available reference clock rates.

Returns
  a list of clock rate ranges in Hz

## ◆ get_sample_rate()

virtual double gr::soapy::block::get_sample_rate | ( | size_t | channel | ) | const
| pure virtual

Get the baseband sample rate of the RX chain.

Parameters

  channel | an available channel on the device

Returns
  the sample rate in samples per second

## ◆ get_sample_rate_range()

virtual range_list_t gr::soapy::block::get_sample_rate_range | ( | size_t | channel | ) | const
| pure virtual

Get the range of possible baseband sample rates.

Parameters

  channel | an available channel on the device

Returns
  a list of sample rate ranges in samples per second

## ◆ get_sensor_info() [1/2]

virtual arginfo_t gr::soapy::block::get_sensor_info | ( | const std::string & | key | ) | const
| pure virtual

Get meta-information about a sensor. Example: displayable name, type, range.

Parameters

  key | the ID name of an available sensor

Returns
  meta-information about a sensor

## ◆ get_sensor_info() [2/2]

virtual arginfo_t gr::soapy::block::get_sensor_info | ( | size_t | channel,
|  | const std::string & | key ) const
| pure virtual

Get meta-information about a channel sensor. Example: displayable name, type, range.

Parameters

  channel | an available channel on the device
  key | the ID name of an available sensor

Returns
  meta-information about a sensor

## ◆ get_setting_info() [1/2]

virtual arginfo_list_t gr::soapy::block::get_setting_info | ( |  | ) | const
| pure virtual

Describe the allowed keys and values used for settings.

Returns
  a list of argument info structures

## ◆ get_setting_info() [2/2]

virtual arginfo_list_t gr::soapy::block::get_setting_info | ( | size_t | channel | ) | const
| pure virtual

Describe the allowed keys and values used for channel settings.

Parameters

  channel | an available channel on the device

Returns
  a list of argument info structures

## ◆ get_time_source()

virtual std::string gr::soapy::block::get_time_source | ( |  | ) | const
| pure virtual

Get the time source of the device

Returns
  the name of a time source

## ◆ has_dc_offset()

virtual bool gr::soapy::block::has_dc_offset | ( | size_t | channel | ) | const
| pure virtual

Return whether manual dc offset correction is supported

Parameters

  channel | an available channel

## ◆ has_dc_offset_mode()

virtual bool gr::soapy::block::has_dc_offset_mode | ( | size_t | channel | ) | const
| pure virtual

Return whether DC offset mode can be set

Parameters

  channel | an available channel

## ◆ has_frequency_correction()

virtual bool gr::soapy::block::has_frequency_correction | ( | size_t | channel | ) | const
| pure virtual

Return whether frequency correction is supported

Parameters

  channel | an available channel

## ◆ has_gain_mode()

virtual bool gr::soapy::block::has_gain_mode | ( | size_t | channel | ) | const
| pure virtual

Return whether automatic gain control (AGC) is supported

Parameters

  channel | an available channel

## ◆ has_hardware_time()

virtual bool gr::soapy::block::has_hardware_time | ( | const std::string & | what = "" | ) | const
| pure virtual

Does this device have a hardware clock?

Parameters

  what | optional argument

Returns
  true if the hardware clock exists

## ◆ has_iq_balance()

virtual bool gr::soapy::block::has_iq_balance | ( | size_t | channel | ) | const
| pure virtual

Return whether manual IQ balance correction is supported

Parameters

  channel | an available channel

## ◆ has_iq_balance_mode()

virtual bool gr::soapy::block::has_iq_balance_mode | ( | size_t | channel | ) | const
| pure virtual

Does the device support automatic frontend IQ balance correction?

Parameters

  channel | an available channel on the device

Returns
  true if IQ balance corrections are supported

## ◆ list_antennas()

virtual std::vector< std::string > gr::soapy::block::list_antennas | ( | int | channel | ) | const
| pure virtual

List available antennas for a channel

Parameters

  channel | channel index

Returns
  available antenna names

## ◆ list_clock_sources()

virtual std::vector< std::string > gr::soapy::block::list_clock_sources | ( |  | ) | const
| pure virtual

Get the list of available clock sources.

Returns
  a list of clock source names

## ◆ list_frequencies()

virtual std::vector< std::string > gr::soapy::block::list_frequencies | ( | size_t | channel | ) | const
| pure virtual

List available tunable elements in the chain. Elements should be in order RF to baseband.

Parameters

  channel | an available channel

Returns
  a list of tunable elements by name

## ◆ list_gains()

virtual std::vector< std::string > gr::soapy::block::list_gains | ( | size_t | channel | ) | const
| pure virtual

List available amplification elements. Elements should be in order RF to baseband.

Parameters

  channel | an available channel

Returns
  a list of gain string names

## ◆ list_gpio_banks()

virtual std::vector< std::string > gr::soapy::block::list_gpio_banks | ( |  | ) | const
| pure virtual

Get a list of available GPIO banks by name.

## ◆ list_register_interfaces()

virtual std::vector< std::string > gr::soapy::block::list_register_interfaces | ( |  | ) | const
| pure virtual

Get a list of available register interfaces by name.

Returns
  a list of available register interfaces

## ◆ list_sensors() [1/2]

virtual std::vector< std::string > gr::soapy::block::list_sensors | ( |  | ) | const
| pure virtual

List the available global readback sensors. A sensor can represent a reference lock, RSSI, temperature.

Returns
  a list of available sensor string names

## ◆ list_sensors() [2/2]

virtual std::vector< std::string > gr::soapy::block::list_sensors | ( | size_t | channel | ) | const
| pure virtual

List the available channel readback sensors. A sensor can represent a reference lock, RSSI, temperature.

Parameters

  channel | an available channel on the device

Returns
  a list of available sensor string names

## ◆ list_time_sources()

virtual std::vector< std::string > gr::soapy::block::list_time_sources | ( |  | ) | const
| pure virtual

Get the list of available time sources.

Returns
  a list of time source names

## ◆ list_uarts()

virtual std::vector< std::string > gr::soapy::block::list_uarts | ( |  | ) | const
| pure virtual

Enumerate the available UART devices.

Returns
  a list of names of available UARTs

## ◆ read_gpio()

virtual unsigned gr::soapy::block::read_gpio | ( | const std::string & | bank | ) | const
| pure virtual

Readback the value of a GPIO bank.

Parameters

  bank | the name of an available bank

Returns
  an integer representing GPIO bits

## ◆ read_gpio_dir()

virtual unsigned gr::soapy::block::read_gpio_dir | ( | const std::string & | bank | ) | const
| pure virtual

Read the data direction of a GPIO bank. 1 bits represent outputs, 0 bits represent inputs.

Parameters

  bank | the name of an available bank

Returns
  an integer representing data direction bits

## ◆ read_i2c()

virtual std::string gr::soapy::block::read_i2c | ( | int | addr,
|  | size_t | num_bytes )
| pure virtual

Read from an available I2C slave. If the device contains multiple I2C masters, the address bits can encode which master.

Parameters

  addr | the address of the slave
  num_bytes | the number of bytes to read

Returns
  an array of bytes read from the slave

## ◆ read_register()

virtual unsigned gr::soapy::block::read_register | ( | const std::string & | name,
|  | unsigned | addr ) const
| pure virtual

Read a register on the device given the interface name.

Parameters

  name | the name of a available register interface
  addr | the register address

Returns
  the register value

References gr::basic_block::name().

## ◆ read_registers()

virtual std::vector< unsigned > gr::soapy::block::read_registers | ( | const std::string & | name,
|  | unsigned | addr,
|  | size_t | length ) const
| pure virtual

Read a memory block on the device given the interface name.

Parameters

  name | the name of a available memory block interface
  addr | the memory block start address
  length | number of words to be read from memory block

Returns
  the memory block content

References gr::basic_block::name().

## ◆ read_sensor() [1/2]

virtual std::string gr::soapy::block::read_sensor | ( | const std::string & | key | ) | const
| pure virtual

Readback a global sensor given the name. The value returned is a string which can represent a boolean ("true"/"false"), an integer, or float.

Parameters

  key | the ID name of an available sensor

Returns
  the current value of the sensor

## ◆ read_sensor() [2/2]

virtual std::string gr::soapy::block::read_sensor | ( | size_t | channel,
|  | const std::string & | key ) const
| pure virtual

Readback a channel sensor given the name. The value returned is a string which can represent a boolean ("true"/"false"), an integer, or float.

Parameters

  channel | an available channel on the device
  key | the ID name of an available sensor

Returns
  the current value of the sensor

## ◆ read_setting() [1/2]

virtual std::string gr::soapy::block::read_setting | ( | const std::string & | key | ) | const
| pure virtual

Read an arbitrary setting on the device.

Parameters

  key | the setting identifier

Returns
  the setting value

## ◆ read_setting() [2/2]

virtual std::string gr::soapy::block::read_setting | ( | size_t | channel,
|  | const std::string & | key ) const
| pure virtual

Read an arbitrary channel setting on the device.

Parameters

  channel | an available channel on the device
  key | the setting identifier

Returns
  the setting value

## ◆ read_uart()

virtual std::string gr::soapy::block::read_uart | ( | const std::string & | which,
|  | long | timeout_us = 100000 ) const
| pure virtual

Read bytes from a UART until timeout or newline. Its up to the implementation to set the baud rate, carriage return settings, flushing on newline.

Parameters

  which | the name of an available UART
  timeout_us | a timeout in microseconds

Returns
  an array of bytes read from the UART

## ◆ set_antenna()

virtual void gr::soapy::block::set_antenna | ( | size_t | channel,
|  | const std::string & | name )
| pure virtual

Set antenna for channel

Parameters

  channel | an available channel
  name | an available antenna string name

References gr::basic_block::name().

## ◆ set_bandwidth()

virtual void gr::soapy::block::set_bandwidth | ( | size_t | channel,
|  | double | bandwidth )
| pure virtual

Set filter bandwidth

Parameters

  channel | an available channel
  bandwidth | filter width in Hz

## ◆ set_clock_source()

virtual void gr::soapy::block::set_clock_source | ( | const std::string & | clock_source | ) |
| pure virtual

Set the clock source

Parameters

  clock_source | an available clock source

## ◆ set_dc_offset()

virtual void gr::soapy::block::set_dc_offset | ( | size_t | channel,
|  | const gr_complexd & | dc_offset )
| pure virtual

Set dc offset correction

Parameters

  channel | an available channel
  dc_offset | complex dc offset correction

## ◆ set_dc_offset_mode()

virtual void gr::soapy::block::set_dc_offset_mode | ( | size_t | channel,
|  | bool | automatic )
| pure virtual

Set DC offset mode

Parameters

  channel | an available channel
  automatic | true to set automatic DC removal

## ◆ set_frequency() [1/2]

virtual void gr::soapy::block::set_frequency | ( | size_t | channel,
|  | const std::string & | name,
|  | double | freq )
| pure virtual

Set center frequency of a tunable element

Parameters

  channel | an available channel
  name | an available element name
  freq | frequency in Hz

References gr::basic_block::name().

## ◆ set_frequency() [2/2]

virtual void gr::soapy::block::set_frequency | ( | size_t | channel,
|  | double | freq )
| pure virtual

Set device center frequency

Parameters

  channel | an available channel
  freq | frequency in Hz

## ◆ set_frequency_correction()

virtual void gr::soapy::block::set_frequency_correction | ( | size_t | channel,
|  | double | freq_correction )
| pure virtual

Set frequency correction

Parameters

  channel | an available channel
  freq_correction | in PPM

## ◆ set_frontend_mapping()

virtual void gr::soapy::block::set_frontend_mapping | ( | const std::string & | frontend_mapping | ) |
| pure virtual

Set the frontend mapping of available DSP units to RF frontends. This mapping controls channel mapping and channel availability.

Parameters

  frontend_mapping | a vendor-specific mapping string

## ◆ set_gain() [1/2]

virtual void gr::soapy::block::set_gain | ( | size_t | channel,
|  | const std::string & | name,
|  | double | gain )
| pure virtual

Set specific gain value

Parameters

  channel | an available channel
  name | gain name to set
  gain | gain value

References gr::basic_block::name().

## ◆ set_gain() [2/2]

virtual void gr::soapy::block::set_gain | ( | size_t | channel,
|  | double | gain )
| pure virtual

Set overall gain The gain will be distributed automatically across available elements according to Soapy API.

Parameters

  channel | an available channel
  gain | overall gain value

## ◆ set_gain_mode()

virtual void gr::soapy::block::set_gain_mode | ( | size_t | channel,
|  | bool | enable )
| pure virtual

Set automatic gain control (AGC)

Parameters

  channel | an available channel
  enable | true to enable AGC

## ◆ set_hardware_time()

virtual void gr::soapy::block::set_hardware_time | ( | long long | timeNs,
|  | const std::string & | what = "" )
| pure virtual

Write the time to the hardware clock on the device. The what argument can refer to a specific time counter.

Parameters

  timeNs | time in nanoseconds
  what | optional argument

## ◆ set_iq_balance()

virtual void gr::soapy::block::set_iq_balance | ( | size_t | channel,
|  | const gr_complexd & | iq_balance )
| pure virtual

Set IQ balance correction

Parameters

  channel | an available channel
  iq_balance | complex iq balance correction

## ◆ set_iq_balance_mode()

virtual void gr::soapy::block::set_iq_balance_mode | ( | size_t | channel,
|  | bool | automatic )
| pure virtual

Set the automatic frontend IQ balance correction.

Parameters

  channel | an available channel on the device
  automatic | true for automatic correction

## ◆ set_master_clock_rate()

virtual void gr::soapy::block::set_master_clock_rate | ( | double | clock_rate | ) |
| pure virtual

Set master clock rate

Parameters

  clock_rate | clock rate in Hz

## ◆ set_reference_clock_rate()

virtual void gr::soapy::block::set_reference_clock_rate | ( | double | rate | ) |
| pure virtual

Set the reference clock rate of the device.

Parameters

  rate | the clock rate in Hz

## ◆ set_sample_rate()

virtual void gr::soapy::block::set_sample_rate | ( | size_t | channel,
|  | double | sample_rate )
| pure virtual

Set sample rate

Parameters

  channel | an available channel
  sample_rate | samples per second

## ◆ set_time_source()

virtual void gr::soapy::block::set_time_source | ( | const std::string & | source | ) |
| pure virtual

Set the time source on the device

Parameters

  source | the name of a time source

## ◆ transact_spi()

virtual unsigned gr::soapy::block::transact_spi | ( | int | addr,
|  | unsigned | data,
|  | size_t | num_bits )
| pure virtual

Perform a SPI transaction and return the result. Its up to the implementation to set the clock rate, and read edge, and the write edge of the SPI core. SPI slaves without a readback pin will return 0.

If the device contains multiple SPI masters, the address bits can encode which master.

Parameters

  addr | an address of an available SPI slave
  data | the SPI data, num_bits-1 is first out
  num_bits | the number of bits to clock out

Returns
  the readback data, num_bits-1 is first in

## ◆ write_gpio() [1/2]

virtual void gr::soapy::block::write_gpio | ( | const std::string & | bank,
|  | unsigned | value )
| pure virtual

Write the value of a GPIO bank.

Parameters

  bank | the name of an available bank
  value | an integer representing GPIO bits

## ◆ write_gpio() [2/2]

virtual void gr::soapy::block::write_gpio | ( | const std::string & | bank,
|  | unsigned | value,
|  | unsigned | mask )
| pure virtual

Write the value of a GPIO bank with modification mask.

Parameters

  bank | the name of an available bank
  value | an integer representing GPIO bits
  mask | a modification mask where 1 = modify

## ◆ write_gpio_dir() [1/2]

virtual void gr::soapy::block::write_gpio_dir | ( | const std::string & | bank,
|  | unsigned | dir )
| pure virtual

Write the data direction of a GPIO bank. 1 bits represent outputs, 0 bits represent inputs.

Parameters

  bank | the name of an available bank
  dir | an integer representing data direction bits

## ◆ write_gpio_dir() [2/2]

virtual void gr::soapy::block::write_gpio_dir | ( | const std::string & | bank,
|  | unsigned | dir,
|  | unsigned | mask )
| pure virtual

Write the data direction of a GPIO bank with modification mask. 1 bits represent outputs, 0 bits represent inputs.

Parameters

  bank | the name of an available bank
  dir | an integer representing data direction bits
  mask | a modification mask where 1 = modify

## ◆ write_i2c()

virtual void gr::soapy::block::write_i2c | ( | int | addr,
|  | const std::string & | data )
| pure virtual

Write to an available I2C slave. If the device contains multiple I2C masters, the address bits can encode which master.

Parameters

  addr | the address of the slave
  data | an array of bytes write out

## ◆ write_register()

virtual void gr::soapy::block::write_register | ( | const std::string & | name,
|  | unsigned | addr,
|  | unsigned | value )
| pure virtual

Write a register on the device given the interface name. This can represent a register on a soft CPU, FPGA, IC; the interpretation is up the implementation to decide.

Parameters

  name | the name of a available register interface
  addr | the register address
  value | the register value

References gr::basic_block::name().

## ◆ write_registers()

virtual void gr::soapy::block::write_registers | ( | const std::string & | name,
|  | unsigned | addr,
|  | const std::vector< unsigned > & | value )
| pure virtual

Write a memory block on the device given the interface name. This can represent a memory block on a soft CPU, FPGA, IC; the interpretation is up the implementation to decide.

Parameters

  name | the name of a available memory block interface
  addr | the memory block start address
  value | the memory block content

References gr::basic_block::name().

## ◆ write_setting() [1/2]

virtual void gr::soapy::block::write_setting | ( | const std::string & | key,
|  | const std::string & | value )
| pure virtual

Write an arbitrary setting on the device. The interpretation is up the implementation.

Parameters

  key | the setting identifier
  value | the setting value

## ◆ write_setting() [2/2]

virtual void gr::soapy::block::write_setting | ( | size_t | channel,
|  | const std::string & | key,
|  | const std::string & | value )
| pure virtual

Write an arbitrary channel setting on the device. The interpretation is up the implementation.

Parameters

  channel | an available channel on the device
  key | the setting identifier
  value | the setting value

## ◆ write_uart()

virtual void gr::soapy::block::write_uart | ( | const std::string & | which,
|  | const std::string & | data )
| pure virtual

Write data to a UART device. Its up to the implementation to set the baud rate, carriage return settings, flushing on newline.

Parameters

  which | the name of an available UART
  data | an array of bytes to write out

The documentation for this class was generated from the following file:

- gr-soapy/include/gnuradio/soapy/block.h